diff a/test/micro/org/openjdk/bench/valhalla/arraytotal/set/Inline64longSetVal.java b/test/micro/org/openjdk/bench/valhalla/arraytotal/set/Inline64longSetVal.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/arraytotal/set/Inline64longSetVal.java
@@ -0,0 +1,218 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.arraytotal.set;
+
+import org.openjdk.bench.valhalla.arraytotal.util.StatesQ64long;
+import org.openjdk.bench.valhalla.types.Int64;
+import org.openjdk.bench.valhalla.types.Q64long;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Inline64longSetVal extends StatesQ64long {
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public static Q64long get(int i) {
+        return new Q64long(i);
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_as_Val_set0(Val_as_Val st) {
+        Q64long[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = get(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_as_Val_set1(Val_as_Val st) {
+        int len = st.arr.length;
+        for (int i = 0; i < len; i++) {
+            st.arr[i] = get(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_as_Ref_set0(Val_as_Ref st) {
+        Q64long[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = get(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_as_Ref_set1(Val_as_Ref st) {
+        int len = st.arr.length;
+        for (int i = 0; i < len; i++) {
+            st.arr[i] = get(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Ref_as_Ref_set0(Ref_as_Ref st) {
+        Q64long[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = get(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Ref_as_Ref_set1(Ref_as_Ref st) {
+        int len = st.arr.length;
+        for (int i = 0; i < len; i++) {
+            st.arr[i] = get(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_as_Int_set0(Val_as_Int st) {
+        Int64[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = get(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_as_Int_set1(Val_as_Int st) {
+        int len = st.arr.length;
+        for (int i = 0; i < len; i++) {
+            st.arr[i] = get(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Ref_as_Int_set0(Ref_as_Int st) {
+        Int64[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = get(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Ref_as_Int_set1(Ref_as_Int st) {
+        int len = st.arr.length;
+        for (int i = 0; i < len; i++) {
+            st.arr[i] = get(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Int_as_Int_set0(Int_as_Int st) {
+        Int64[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = get(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Int_as_Int_set1(Int_as_Int st) {
+        int len = st.arr.length;
+        for (int i = 0; i < len; i++) {
+            st.arr[i] = get(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_as_Obj_set0(Val_as_Obj st) {
+        Object[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = get(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_as_Obj_set1(Val_as_Obj st) {
+        int len = st.arr.length;
+        for (int i = 0; i < len; i++) {
+            st.arr[i] = get(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Ref_as_Obj_set0(Ref_as_Obj st) {
+        Object[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = get(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Ref_as_Obj_set1(Ref_as_Obj st) {
+        int len = st.arr.length;
+        for (int i = 0; i < len; i++) {
+            st.arr[i] = get(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Int_as_Obj_set0(Int_as_Obj st) {
+        Object[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = get(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Int_as_Obj_set1(Int_as_Obj st) {
+        int len = st.arr.length;
+        for (int i = 0; i < len; i++) {
+            st.arr[i] = get(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Obj_as_Obj_set0(Obj_as_Obj st) {
+        Object[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = get(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Obj_as_Obj_set1(Obj_as_Obj st) {
+        int len = st.arr.length;
+        for (int i = 0; i < len; i++) {
+            st.arr[i] = get(i);
+        }
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/arraytotal/sum/Identity64long.java b/test/micro/org/openjdk/bench/valhalla/arraytotal/sum/Identity64long.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/arraytotal/sum/Identity64long.java
@@ -0,0 +1,100 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.arraytotal.sum;
+
+import org.openjdk.bench.valhalla.arraytotal.util.StatesR64long;
+import org.openjdk.bench.valhalla.types.A64long;
+import org.openjdk.bench.valhalla.types.ByLong;
+import org.openjdk.bench.valhalla.types.R64long;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Identity64long extends StatesR64long {
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public long Ref_as_Ref_fields(Ref_as_Ref st) {
+        long s = 0;
+        R64long[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].v0;
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public long Ref_as_Abs_sum(Ref_as_Abs st) {
+        long s = 0;
+        A64long[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].longSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public long Ref_as_Int_sum(Ref_as_By st) {
+        long s = 0;
+        ByLong[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].longSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public long Abs_as_Abs_sum(Abs_as_Abs st) {
+        long s = 0;
+        A64long[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].longSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public long Abs_as_Int_sum(Abs_as_By st) {
+        long s = 0;
+        ByLong[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].longSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public long Int_as_Int_sum(By_as_By st) {
+        long s = 0;
+        ByLong[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].longSum();
+        }
+        return s;
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/arraytotal/sum/Inline64long.java b/test/micro/org/openjdk/bench/valhalla/arraytotal/sum/Inline64long.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/arraytotal/sum/Inline64long.java
@@ -0,0 +1,231 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.arraytotal.sum;
+
+import org.openjdk.bench.valhalla.arraytotal.util.StatesQ64long;
+import org.openjdk.bench.valhalla.types.ByLong;
+import org.openjdk.bench.valhalla.types.Q64long;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Inline64long extends StatesQ64long {
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public long Val_as_Val_fields0(Val_as_Val st) {
+        long s = 0;
+        Q64long[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].v0;
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public long Val_as_Val_fields1(Val_as_Val st) {
+        long s = 0;
+        int len = st.arr.length;
+        for(int i=0; i < len; i++) {
+            s += st.arr[i].v0;
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public long Val_as_Ref_fields0(Val_as_Ref st) {
+        long s = 0;
+        Q64long[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].v0;
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public long Val_as_Ref_fields1(Val_as_Ref st) {
+        long s = 0;
+        int len = st.arr.length;
+        for(int i=0; i < len; i++) {
+            s += st.arr[i].v0;
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public long Ref_as_Ref_fields0(Ref_as_Ref st) {
+        long s = 0;
+        Q64long[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].v0;
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public long Ref_as_Ref_fields1(Ref_as_Ref st) {
+        long s = 0;
+        int len = st.arr.length;
+        for(int i=0; i < len; i++) {
+            s += st.arr[i].v0;
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public long Val_as_Val_sum0(Val_as_Val st) {
+        long s = 0;
+        Q64long[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].longSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public long Val_as_Val_sum1(Val_as_Val st) {
+        long s = 0;
+        int len = st.arr.length;
+        for(int i=0; i < len; i++) {
+            s += st.arr[i].longSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public long Val_as_Ref_sum0(Val_as_Ref st) {
+        long s = 0;
+        Q64long[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].longSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public long Val_as_Ref_sum1(Val_as_Ref st) {
+        long s = 0;
+        int len = st.arr.length;
+        for(int i=0; i < len; i++) {
+            s += st.arr[i].longSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public long Val_as_Int_sum0(Val_as_By st) {
+        long s = 0;
+        ByLong[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].longSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public long Val_as_Int_sum1(Val_as_By st) {
+        long s = 0;
+        int len = st.arr.length;
+        for(int i=0; i < len; i++) {
+            s += st.arr[i].longSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public long Ref_as_Ref_sum0(Ref_as_Ref st) {
+        long s = 0;
+        Q64long[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].longSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public long Ref_as_Ref_sum1(Ref_as_Ref st) {
+        long s = 0;
+        int len = st.arr.length;
+        for(int i=0; i < len; i++) {
+            s += st.arr[i].longSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public long Ref_as_Int_sum0(Ref_as_By st) {
+        long s = 0;
+        ByLong[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].longSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public long Ref_as_Int_sum1(Ref_as_By st) {
+        long s = 0;
+        int len = st.arr.length;
+        for(int i=0; i < len; i++) {
+            s += st.arr[i].longSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public long Int_as_Int_sum0(By_as_By st) {
+        long s = 0;
+        ByLong[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].longSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public long Int_as_Int_sum1(By_as_By st) {
+        long s = 0;
+        int len = st.arr.length;
+        for(int i=0; i < len; i++) {
+            s += st.arr[i].longSum();
+        }
+        return s;
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/arraytotal/util/StatesQ64long.java b/test/micro/org/openjdk/bench/valhalla/arraytotal/util/StatesQ64long.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/arraytotal/util/StatesQ64long.java
@@ -0,0 +1,185 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.arraytotal.util;
+
+import org.openjdk.bench.valhalla.types.ByLong;
+import org.openjdk.bench.valhalla.types.Int64;
+import org.openjdk.bench.valhalla.types.Q64long;
+import org.openjdk.bench.valhalla.util.SizeBase;
+import org.openjdk.jmh.annotations.Setup;
+
+public class StatesQ64long extends SizeBase {
+
+    public static abstract class ObjState extends SizeState {
+        public Object[] arr;
+        void fill() {
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new Q64long(i);
+            }
+        }
+    }
+
+    public static abstract class IntState extends SizeState {
+        public Int64[] arr;
+        void fill() {
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new Q64long(i);
+            }
+        }
+    }
+
+    public static abstract class RefState extends SizeState {
+        public Q64long[] arr;
+        void fill() {
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new Q64long(i);
+            }
+        }
+    }
+
+    public static abstract class ValState extends SizeState {
+        public Q64long[] arr;
+        void fill() {
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new Q64long(i);
+            }
+        }
+    }
+
+    // naming convention: <runtime array type>_as_<static array type>
+
+    public static class Obj_as_Obj extends ObjState {
+        @Setup
+        public void setup() {
+            arr = new Object[size];
+            fill();
+        }
+    }
+
+    public static class Int_as_Obj extends ObjState {
+        @Setup
+        public void setup() {
+            arr = new Int64[size];
+            fill();
+        }
+    }
+
+    public static class Ref_as_Obj extends ObjState {
+        @Setup
+        public void setup() {
+            arr = new Q64long[size];
+            fill();
+        }
+    }
+
+    public static class Val_as_Obj extends ObjState {
+        @Setup
+        public void setup() {
+            arr = new Q64long[size];
+            fill();
+        }
+    }
+
+    public static class Int_as_Int extends IntState {
+        @Setup
+        public void setup() {
+            arr = new Int64[size];
+            fill();
+        }
+    }
+
+    public static class Ref_as_Int extends IntState {
+        @Setup
+        public void setup() {
+            arr = new Q64long[size];
+            fill();
+        }
+    }
+
+    public static class Val_as_Int extends IntState {
+        @Setup
+        public void setup() {
+            arr = new Q64long[size];
+            fill();
+        }
+    }
+
+    public static class Ref_as_Ref extends RefState {
+        @Setup
+        public void setup() {
+            arr = new Q64long[size];
+            fill();
+        }
+    }
+
+    public static class Val_as_Ref extends RefState {
+        @Setup
+        public void setup() {
+            arr = new Q64long[size];
+            fill();
+        }
+    }
+
+    public static class Val_as_Val extends ValState {
+        @Setup
+        public void setup() {
+            arr = new Q64long[size];
+            fill();
+        }
+    }
+
+    public static abstract class ByState extends SizeState {
+        public ByLong[] arr;
+        void fill() {
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new Q64long(i);
+            }
+        }
+    }
+
+    public static class Val_as_By extends ByState {
+        @Setup
+        public void setup() {
+            arr = new Q64long[size];
+            fill();
+        }
+    }
+
+    public static class Ref_as_By extends ByState {
+        @Setup
+        public void setup() {
+            arr = new Q64long[size];
+            fill();
+        }
+    }
+
+    public static class By_as_By extends ByState {
+        @Setup
+        public void setup() {
+            arr = new ByLong[size];
+            fill();
+        }
+    }
+
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/arraytotal/util/StatesR64long.java b/test/micro/org/openjdk/bench/valhalla/arraytotal/util/StatesR64long.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/arraytotal/util/StatesR64long.java
@@ -0,0 +1,187 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.arraytotal.util;
+
+import org.openjdk.bench.valhalla.types.ByLong;
+import org.openjdk.bench.valhalla.types.Int64;
+import org.openjdk.bench.valhalla.types.R64long;
+import org.openjdk.bench.valhalla.types.A64long;
+import org.openjdk.bench.valhalla.util.SizeBase;
+import org.openjdk.jmh.annotations.Setup;
+
+public class StatesR64long extends SizeBase {
+
+    public static abstract class ObjState extends SizeState {
+        public Object[] arr;
+        void fill() {
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new R64long(i);
+            }
+        }
+    }
+
+    public static abstract class IntState extends SizeState {
+        public Int64[] arr;
+        void fill() {
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new R64long(i);
+            }
+        }
+    }
+
+    public static abstract class AbsState extends SizeState {
+        public A64long[] arr;
+        void fill() {
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new R64long(i);
+            }
+        }
+    }
+
+    public static abstract class RefState extends SizeState {
+        public R64long[] arr;
+        void fill() {
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new R64long(i);
+            }
+        }
+    }
+
+    // naming convention: <runtime array type>_as_<static array type>
+
+    public static class Obj_as_Obj extends ObjState {
+        @Setup
+        public void setup() {
+            arr = new Object[size];
+            fill();
+        }
+    }
+
+    public static class Int_as_Obj extends ObjState {
+        @Setup
+        public void setup() {
+            arr = new Int64[size];
+            fill();
+        }
+    }
+
+    public static class Abs_as_Obj extends ObjState {
+        @Setup
+        public void setup() {
+            arr = new A64long[size];
+            fill();
+        }
+    }
+
+    public static class Ref_as_Obj extends ObjState {
+        @Setup
+        public void setup() {
+            arr = new R64long[size];
+            fill();
+        }
+    }
+
+    public static class Int_as_Int extends IntState {
+        @Setup
+        public void setup() {
+            arr = new Int64[size];
+            fill();
+        }
+    }
+
+    public static class Abs_as_Int extends IntState {
+        @Setup
+        public void setup() {
+            arr = new A64long[size];
+            fill();
+        }
+    }
+
+    public static class Ref_as_Int extends IntState {
+        @Setup
+        public void setup() {
+            arr = new R64long[size];
+            fill();
+        }
+    }
+
+    public static class Abs_as_Abs extends AbsState {
+        @Setup
+        public void setup() {
+            arr = new A64long[size];
+            fill();
+        }
+    }
+
+    public static class Ref_as_Abs extends AbsState {
+        @Setup
+        public void setup() {
+            arr = new R64long[size];
+            fill();
+        }
+    }
+
+    public static class Ref_as_Ref extends RefState {
+        @Setup
+        public void setup() {
+            arr = new R64long[size];
+            fill();
+        }
+    }
+
+    public static abstract class ByState extends SizeState {
+        public ByLong[] arr;
+        void fill() {
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = new R64long(i);
+            }
+        }
+    }
+
+    public static class Ref_as_By extends ByState {
+        @Setup
+        public void setup() {
+            arr = new R64long[size];
+            fill();
+        }
+    }
+
+    public static class Abs_as_By extends ByState {
+        @Setup
+        public void setup() {
+            arr = new A64long[size];
+            fill();
+        }
+    }
+
+    public static class By_as_By extends ByState {
+        @Setup
+        public void setup() {
+            arr = new ByLong[size];
+            fill();
+        }
+    }
+
+
+
+}
